// GITVERSION: texstuff-1.4.0-755-g0cd67ca6
#ifndef EVAL_HPP
#define EVAL_HPP
#include "aedtools/evalbase.hpp"
#include "aedtools/str_convs.hpp"
#include <forward_list>
#include <sstream>
using namespace std;

namespace aed {
  
  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
  //   FUNCTIONS FOR THIS EXAM
  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>

  void json2vv(vector<vector<int>> &vv,json &j) {
    vv.clear();
    for (auto x : j) {
      vector<int> w = x;
      vv.push_back(w);
    }
  }

  void vv2json(json &jvv,vector<vector<int>> &vv) {
      for (auto &x : vv) {
        json vj = x;
        jvv.push_back(vj);
      }
  }
  
  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
  // END FUNCTIONS FOR THIS EXAM
  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
  
  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
#undef EJERC
#undef EVAL
#define EJERC 1
#define EVAL eval1_t
  
  typedef void (*sort_vec_sum_t)(vector<vector<int>> &vv);
  class eval1_t : public eval_base_t {
  public:
    sort_vec_sum_t F;
    EVAL() {
      dumptests=0;
      const char *dt = getenv("DUMPTESTS");
      if (dt && !strcmp(dt,"1")) dumptests=1;
      F=NULL; ejerc=EJERC; testfile="./svs.json";
    }
    
    void run_case(json &data, json &outuser) {
      // check_dni();
      vector<vector<int>> vv;
#if 0
      for (auto &x : data["vv"]) {
        vector<int> vz;
        for (auto &z : x)
          vz.push_back(z);
        vv.push_back(vz);
      }
#endif
      F(vv);
      
      json vvnew = json::array();
      for (auto &x : vv) {
        json vj = x;
        vvnew.push_back(vj);
      }
      outuser["vv"] = vvnew;
    }
    
    int check_case(json &datain,
                   json &outref,json &outuser) {
      return outref==outuser;
    }
                   
    void generate_case(randomg_t &rnd,json &datain) {
      json vv;
      int nv = 2+rnd.rand()%4;
      for (int j=0; j<nv; j++) {
        json w;
        int nz = 1+rnd.rand()%6;
        for (int k=0; k<nz; k++) 
          w.push_back(rnd.rand()%10);
        vv.push_back(w);
      }
      datain["vv"] = vv;
    }
  };

  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
#undef EJERC
#undef EVAL
#define EJERC 2
#define EVAL eval2_t
  
  typedef void (*splitm_t)(vector<int> &v,int m,vector<vector<int>> &vv);
  class EVAL : public eval_base_t {
  public:
    splitm_t F;
    EVAL() {
      dumptests=0;
      const char *dt = getenv("DUMPTESTS");
      if (dt && !strcmp(dt,"1")) dumptests=1;
      F=NULL; ejerc=EJERC; testfile="./sm.json";
    }
    
    void run_case(json &data, json &outuser) {
      // check_dni();
      vector<int> v = data["v"];
      int m = data["m"];
      vector<vector<int>> vv;
      F(v,m,vv);
      json jvv;
      vv2json(jvv,vv);
      outuser["vv"] = jvv;
    }
    
    int check_case(json &datain,
                   json &outref,json &outuser) {
      return outref==outuser;
    }
                   
    void generate_case(randomg_t &rnd,json &datain) {
      json jv;
      int nv = 2+rnd.rand()%15;
      for (int j=0; j<nv; j++) jv.push_back(1+rnd.rand()%9);
      datain["v"] = jv;
      datain["m"] = 10+rnd.rand()%10;
    }
  };

  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
#undef EJERC
#undef EVAL
#define EJERC 3
#define EVAL eval3_t
  
  typedef void (*insert_t)(vector<int> &v1,int indx,vector<int> &v2);
  class EVAL : public eval_base_t {
  public:
    insert_t F;
    EVAL() {
      dumptests=0;
      const char *dt = getenv("DUMPTESTS");
      if (dt && !strcmp(dt,"1")) dumptests=1;
      F=NULL; ejerc=EJERC; testfile="./ins.json";
    }
    
    void run_case(json &data, json &outuser) {
      // check_dni();
      vector<int> v1 = data["v1"];
      int indx = data["indx"];
      vector<int> v2 = data["v2"];
      F(v1,indx,v2);
      outuser["v1"] = v1;
    }
    
    int check_case(json &datain,
                   json &outref,json &outuser) {
      return outref==outuser;
    }
                   
    void generate_case(randomg_t &rnd,json &datain) {
      int n1= 2+rnd.rand()%10;
      int n2= 2+rnd.rand()%5;
      json v1,v2;
      for (int j=0; j<n1; j++) v1.push_back(1+rnd.rand()%9);
      for (int j=0; j<n2; j++) v2.push_back(1+rnd.rand()%9);
      datain["v1"] = v1;
      datain["v2"] = v2;
      datain["indx"] = rnd.rand()%n1;
    }
  };
  
  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
  using Eval = eval_t<eval1_t,sort_vec_sum_t,
                      eval2_t,splitm_t,
                      eval3_t,insert_t>;
}
#undef CSTR

#endif
