// GITVERSION: texstuff-1.4.0-786-g9f6eff91
#ifndef EVAL_HPP
#define EVAL_HPP
#include "aedtools/evalbase.hpp"
#include "aedtools/str_convs.hpp"
#include <forward_list>
#include <sstream>
using namespace std;

namespace aed {
  
  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
  //   FUNCTIONS FOR THIS EXAM
  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>

  void json2ls(list<set<int>> &ls,json &j) {
    ls.clear();
    for (auto x : j) {
      set<int> s = x;
      ls.push_back(s);
    }
  }

  void ls2json(json &jls,list<set<int>> &ls) {
      for (auto &s : ls) {
        json vj = s;
        jls.push_back(vj);
      }
  }
  
  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
  // END FUNCTIONS FOR THIS EXAM
  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
  
  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
#undef EJERC
#undef EVAL
#define EJERC 1
#define EVAL eval1_t
  
  typedef void (*keepset_t)(list<set<int>> &LS,
                            list<set<int>> &good, list<set<int>> &bad);
  class eval1_t : public eval_base_t {
  public:
    keepset_t F;
    EVAL() {
      dumptests=0;
      const char *dt = getenv("DUMPTESTS");
      if (dt && !strcmp(dt,"1")) dumptests=1;
      F=NULL; ejerc=EJERC; testfile="./ks.json";
    }
    
    void run_case(json &data, json &outuser) {
      // check_dni();
      list<set<int>> ls,good,bad;
      // cout << data["ls"] << endl;
      // cout << data["good"] << endl;
      // cout << data["bad"] << endl;
      json2ls(ls,data["ls"]);
      json2ls(good,data["good"]);
      json2ls(bad,data["bad"]);
      F(ls,good,bad);
      ls2json(outuser["ls"],ls);
    }
    
    int check_case(json &datain,
                   json &outref,json &outuser) {
      return outref==outuser;
    }
                   
    void generate_case(randomg_t &rnd,json &datain) {
      int nb=2,ng=6,nitems=2,
        ns=6+rnd.rand()%4,maxitem=20;
      for (int k=0; k<5; k++) {
        set<int> s;
        for (int j=0; j<ns; j++) s.insert(rnd.rand()%maxitem);
        json js = s;
        datain["ls"].push_back(js);
      }
      set<int> sbglob;
      for (int k=0; k<nb; k++) {
        set<int> sb;
        for (int j=0; j<nitems; j++) {
          sb.insert(rnd.rand()%maxitem);
          sbglob.insert(rnd.rand()%maxitem);
        }
        json jsb = sb;
        datain["bad"].push_back(jsb);
      }
      for (int k=0; k<ng; k++) {
        set<int> sg;
        while (int(sg.size())<nitems) {
          int item = rnd.rand()%maxitem;
          if (sbglob.find(item)==sbglob.end()) sg.insert(item);
        }
        datain["good"].push_back(json(sg));
      }
      // cout << datain << endl;
    }
  };

  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
#undef EJERC
#undef EVAL
#define EJERC 2
#define EVAL eval2_t
  
  typedef bool (*equivlset_t)(list<set<int>> &LSA,list<set<int>> &LSB);
  class eval2_t : public eval_base_t {
  public:
    equivlset_t F;
    EVAL() {
      dumptests=0;
      const char *dt = getenv("DUMPTESTS");
      if (dt && !strcmp(dt,"1")) dumptests=1;
      F=NULL; ejerc=EJERC; testfile="./es.json";
    }
    
    void run_case(json &data, json &outuser) {
      // check_dni();
      list<set<int>> LSA,LSB;
      json2ls(LSA,data["LSA"]);
      json2ls(LSB,data["LSB"]);
      outuser = F(LSA,LSB);
    }
    
    int check_case(json &datain,
                   json &outref,json &outuser) {
      return outref==outuser;
    }
                   
    void generate_case(randomg_t &rnd,json &datain) {
      int ntot=20,n1=4;
      list<int> LA,LAcpy;
      for (int q=0; q<2; q++) {
        list<set<int>> LSA;
        if (q==0 || rnd.rand()%2) {
          // Rehace el vector de 0
          LA.clear();
          for (int j=0; j<ntot; j++) LA.push_back(rnd.rand()%100);
          LAcpy = LA;
        } else {
          // Usa LB = shuffle(LA)
          LA = LAcpy;
          vector<int> VLA;
          for (auto x : LA) VLA.push_back(x);
          std::random_shuffle(VLA.begin(),VLA.end());
          LA.clear();
          for (auto x : VLA) LA.push_back(x);
        }
        // cout << json(LA) << endl;
        while (!LA.empty()) {
          set<int> s;
          int k=0;
          while (k<n1 && !LA.empty()) {
            int x = LA.front();
            LA.pop_front();
            if (s.find(x)==s.end()) s.insert(x);
            else LA.push_back(x);
            k++;
          }
          LSA.push_back(s);
        }
        json jlsa;
        ls2json(jlsa,LSA);
        // cout << jlsa << endl;
        string name = (q==0? "LSA" : "LSB");
        datain[name] = jlsa;
      }
    }
  };
  
  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
  using Eval = eval_t<eval1_t,keepset_t,
                      eval2_t,equivlset_t>;
}
#undef CSTR

#endif
